#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"
#include "VVram.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + 14 * VramStep, "SCORE");
    // PrintS(Vram + VramRowSize * 3 + 24 * VramStep, "HI-SCORE");
    PrintS(Vram + VramRowSize * 3 + 14 * VramStep, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 4 + 18 * VramStep, CurrentStage + 1);
    PrintS(Vram + VramRowSize * 6 + 14 * VramStep, "TIME");
    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 18 + 15 * VramStep;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            pVram = Put2C(pVram, Char_Man);
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    pVram = PrintNumber5(Vram + VramRowSize + 14 * VramStep, Score);
    PrintC(pVram, '0');
    // pVram = PrintNumber5(Vram + VramRowSize * 7 + 26, HiScore);
    // PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 7 + 17 * VramStep, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = Vram + VramRowSize * 16 + 15 * VramStep;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        pVram = Put(pVram, Char_Kn_Left);
        ++i;
        --count;
    }
    while (i != 4) {
        pVram = Put(pVram, Char_Space);
        ++i;
    }
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 8 + (14 - 9) / 2 * VramStep, "GAME OVER");
    // PresendVram();
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 8 + (14 - 7) / 2 * VramStep, "TIME UP");
    // PresendVram();
}

void Title()
{
    ClearScreen(); 
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            0x2c, 0x2a, 0x2a, 0x1f, 
            0x25, 0x2c, 0x1f, 0x21, 
            0x22, 0x2a, 0x20, 0x2c, 
            0x1d, 0x2c, 
            0x2c, 0x29, 0x29, 0x20, 
            0x2c, 0x1d, 0x2c, 0x1d, 
            0x25, 0x24, 0x1d, 0x2a, 
            0x27, 0x24, 
            0x2c, 0x29, 0x29, 0x20, 
            0x2c, 0x22, 0x2c, 0x25, 
            0x24, 0x1d, 0x1d, 0x1d, 
            0x2c, 0x1d, 
            0x22, 0x21, 0x21, 0x1e, 
            0x22, 0x1d, 0x22, 0x21, 
            0x22, 0x22, 0x1e, 0x1d, 
            0x22, 0x1d, 
        };
        constexpr byte LogoWidth = 14;
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 4 + (14 - LogoWidth) / 2 * VramStep;
        p = TitleBytes;
        repeat (4) {
            repeat (LogoWidth) {
                pVram = Put(pVram, *p);
                ++p;
            }
            pVram += VramRowSize - LogoWidth * VramStep;
        }
        PrintS(Vram + VramRowSize * 8 + ((14 + LogoWidth) / 2 - 4) * VramStep, "MINI");
    }
    PrintS(Vram + VramRowSize * 15 + 0 * VramStep, "PUSH START");
    PrintS(Vram + VramRowSize * 16 + 8 * VramStep, "BUTTON");
    PrintS(Vram + VramRowSize * 19 + 2 * VramStep, "INUFUTO 2024");
    // {
    //     ptr<byte> pVram;
    //     byte c;
    //     pVram = Vram;
    //     c = 0;
    //     repeat (16) {
    //         repeat (16) {
    //             pVram = Put(pVram, c);
    //             ++c;
    //         }
    //         pVram += VramRowSize - 16 * VramStep;
    //     }
    // }
    // PresendVram();
}
